# ../gungame51/scripts/custom/gg_dance_off/gg_dance_off_config.py

# ============================================================================
# >> IMPORTS
# ============================================================================
# EventScripts Imports
import es
import cfglib

# GunGame Imports
from gungame51.core.cfg import generate_header

# ============================================================================
# >> GLOBAL VARIABLES
# ============================================================================
config = cfglib.AddonCFG('%s/cfg/' % es.ServerVar('eventscripts_gamedir') +
    'gungame51/custom_addon_configs/gg_dance_off.cfg')
        
# ============================================================================
# >> LOAD & UNLOAD
# ============================================================================

def load():
    generate_header(config)
    
    # Dance Off
    config.text('')
    config.text('='*76)
    config.text('>> DANCE OFF')
    config.text('='*76)
    config.text('Description:')
    config.text('   Prompts players for a dance off when the desired ' +
                'amount of')
    config.text('   players are left.')
    config.text('Options:')
    config.text('   0 = (Disabled) Do not load gg_dance_off.')
    config.text('   1 = (Enabled) Load gg_dance_off.')
    config.text('Default Value: 1')
    config.cvar('gg_dance_off', 1, 
                            'Enables/Disables gg_dance_off.').addFlag('notify')

    # Time
    config.text('')
    config.text('='*76)
    config.text('>> DANCE OFF TIME')
    config.text('='*76)
    config.text('Description:')
    config.text('   The duration of the dance off in seconds.')    
    config.text('Options:')
    config.text('   # = (Enabled) Amount of time allowed.')
    config.text('Default Value: 0')
    config.cvar('gg_dance_off_time', 15, 
                                'Time for gg_dance_off').addFlag('notify')

    # Players
    config.text('')
    config.text('='*76)
    config.text('>> DANCE OFF PLAYERS')
    config.text('='*76)
    config.text('Description:')
    config.text('   The most amount of players allowed to participate in a ' +
                'dance off.')        
    config.text('Options:')
    config.text('   # = (Enabled) Amount of players allowed.')
    config.text('Default Value: 2')
    config.cvar('gg_dance_off_players', 2, 
                            'Player count for gg_dance_off').addFlag('notify')

    # Bots
    config.text('')
    config.text('='*76)
    config.text('>> DANCE OFF BOTS')
    config.text('='*76)
    config.text('Description:')
    config.text('   Allows bots to participate in a dance off. (Yes they do' +
                ' dance.)')        
    config.text('Notes:')
    config.text('   * Even with this enabled at least 1 human needs to be ' +
                'alive.')       
    config.text('   * The human will always win a dance off.')
    config.text('Options:')
    config.text('   0 = (Disabled) Do not allow bots.')
    config.text('   1 = (Enabled) Allow bots.')
    config.text('Default Value: 0')
    config.cvar('gg_dance_off_bots', 0, 
                            'Allows bots in gg_dance_off').addFlag('notify')

    # Allow nades?
    config.text('')
    config.text('='*76)
    config.text('>> DANCE OFF NADE LEVEL')
    config.text('='*76)
    config.text('Description:')
    config.text('   Allow players to skip nade level.')        
    config.text('Options:')
    config.text('   0 = (Disabled) Do not allow players to skip nade.')
    config.text('   1 = (Enabled) Allow players to skip nade.')
    config.text('Default Value: 0')
    config.cvar('gg_dance_off_nade', 0, 
                    'Allows nade skipping in gg_dance_off').addFlag('notify')
                            
    # Allow knives?
    config.text('')
    config.text('='*76)
    config.text('>> DANCE OFF KNIFE LEVEL')
    config.text('='*76)
    config.text('Description:')
    config.text('   Allow players to skip knife level.')        
    config.text('Options:')
    config.text('   0 = (Disabled) Do not allow players to skip knife.')
    config.text('   1 = (Enabled) Allow players to skip knife.')
    config.text('Default Value: 0')
    config.cvar('gg_dance_off_knife', 0, 
                    'Allows knife skipping in gg_dance_off').addFlag('notify')
                                                        
    # Chicken
    config.text('')
    config.text('='*76)
    config.text('>> DANCE OFF CHICKEN MESSAGE')
    config.text('='*76)
    config.text('Description:')
    config.text('   Plays a sound and displays a message to the server when ' +
                'a player')
    config.text('   says no to a dance off.')        
    config.text('Options:')
    config.text('   0 = (Disabled) Don\'t do any chicken messages.')
    config.text('   1 = (Enabled) Play chicken sound and show message.')
    config.text('Default Value: 1')
    config.cvar('gg_dance_off_chicken', 1, 
                'Plays chicken sound/msg in gg_dance_off').addFlag('notify')    

    # Level down?
    config.text('')
    config.text('='*76)
    config.text('>> DANCE OFF LEVEL DOWN LOSERS')
    config.text('='*76)
    config.text('Description:')
    config.text('   All losers will lose a level.')        
    config.text('Options:')
    config.text('   0 = (Disabled) No players lose levels.')
    config.text('   1 = (Enabled) Losers lose a level.')
    config.text('Default Value: 1')
    config.cvar('gg_dance_off_leveldown', 1, 
                    'Losers lose a level in gg_dance_off').addFlag('notify')
                    
    # Levels?
    config.text('')
    config.text('='*76)
    config.text('>> DANCE OFF LEVELS')
    config.text('='*76)
    config.text('Description:')
    config.text('   Defines how many levels are awarded to the winner.')        
    config.text('Options:')   
    config.text('   # = Amount of levels to give to the winner')
    config.text('Default Value: 1')
    config.cvar('gg_dance_off_levels', 1, 
                    'Levels awarded in gg_dance_off').addFlag('notify')                    

    # Sound
    config.text('')
    config.text('='*76)
    config.text('>> DANCE OFF MUSIC')
    config.text('='*76)
    config.text('Description:')
    config.text('   Defines what file to use for music.')        
    config.text('Options:')
    config.text('   0 = (Disabled) No music is played.')
    config.text('Default Value: gungame/dance_off/finaldance.mp3')
    config.cvar('gg_dance_off_sound', 'gungame/dance_off/finaldance.mp3', 
                    'Music for in gg_dance_off').addFlag('notify')   
                    
    # Chicken sound
    config.text('')
    config.text('='*76)
    config.text('>> DANCE OFF CHICKEN SOUND')
    config.text('='*76)
    config.text('Description:')
    config.text('   Defines what file to use for the chicken sound.')        
    config.text('Options:')
    config.text('   0 = (Disabled) No sound is played.')
    config.text('Default Value: gungame/dance_off/chicken.wav')
    config.cvar('gg_dance_off_chicken_sound', 'gungame/dance_off/chicken.wav', 
                    'chicken sound for in gg_dance_off').addFlag('notify')                       

    config.write()
    es.dbgmsg(0, '\tgg_dance_off.cfg')

def unload():
    global config

    # Remove the "notify" flags as set by addFlag('notify')
    for cvar in config.getCvars().keys():
        es.flags('remove', 'notify', cvar)
    
    # Delete the cfglib.AddonCFG instance
    del config